SystemOrganization addCategory: #'MC2-SqueakUI-Browsers'!
SystemOrganization addCategory: #'MC2-SqueakUI-Commands'!
SystemOrganization addCategory: #'MC2-SqueakUI-Definitions'!
SystemOrganization addCategory: #'MC2-SqueakUI-Filters'!
SystemOrganization addCategory: #'MC2-SqueakUI-Nodes'!
SystemOrganization addCategory: #'MC2-SqueakUI-Panels'!
SystemOrganization addCategory: #'MC2-SqueakUI-Tests'!

OBFilter subclass: #MDMemoFilter
	instanceVariableNames: 'ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Filters'!

!MDMemoFilter methodsFor: 'as yet unclassified' stamp: 'cwp 6/11/2008 07:42'!
ancestryOf: parents includes: aHashstamp
	| grandParents |
	grandParents := parents
		inject: Set new
		into:
			[:set :hashstamp |
			set addAll: (ancestry at: hashstamp ifAbsentPut: [#()]).
			set].
	grandParents isEmpty ifTrue: [^ false].
	^ (grandParents includes: aHashstamp) 
		or: [self ancestryOf: grandParents includes: aHashstamp]! !

!MDMemoFilter methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:14'!
displayString: aString forParent: parent child: aNode 
	| parents |
	ancestry ifNil: [ ^ aString ].
	parents := (aNode environment 
		historianWithId: aNode memo sliceId
		ifAbsent: [ ^ aString ]) parents.
	(parents includes: aNode memo hashstamp) ifTrue: 
		[ ^ (Text fromString: aString) 
			addAttribute: TextEmphasis italic
			from: 1
			to: aString size ].
	^ (self 
		ancestryOf: parents
		includes: aNode memo hashstamp) 
		ifTrue: [ aString ]
		ifFalse: [ (Text fromString: aString) allBold ]! !

!MDMemoFilter methodsFor: 'as yet unclassified' stamp: 'cwp 6/12/2008 00:07'!
nodesFrom: aCollection forNode: aNode
	ancestry := Dictionary new.
	aCollection do:
		[:node |
		ancestry 
			at: node memo hashstamp
			put: node memo parents].
	^ aCollection! !

OBFilter subclass: #MDSliceIconFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Filters'!

!MDSliceIconFilter methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:22'!
icon: aSelector forNode: aNode
	| dirty |
	dirty := aNode environment isDirty: aNode slice.
	^ (aNode slice isKindOf: MDMonticelloSlice)
		ifTrue:
			[dirty
				ifTrue: [#monticelloDirty]
				ifFalse: [#monticelloClean]]
		ifFalse:
			[(aNode slice isKindOf: MDUnionSlice)
				ifTrue:
					[dirty
						ifTrue: [#compositeDirty]
						ifFalse: [#blank]]
				ifFalse:
					[dirty
						ifTrue: [#smalltalkDirty]
						ifFalse: [#smalltalkClean]]]! !

OBCommandTest subclass: #MDCmdAddProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddProjectTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:49'!
factory
	^ MDCmdAddProject! !

!MDCmdAddProjectTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 16:54'!
test04ConditionAcceptsRegistry
	| node |
	node := MDEnvironmentNode on: MDEnvironment new.
	self assert: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdAddRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

MDCmdAddRepositoryTest subclass: #MDCmdAddDirRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddDirRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2008 19:52'!
factory
	^ MDCmdAddDirectoryRepository! !

!MDCmdAddDirRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:37'!
repositoryType
	^ #McrDirectory! !

MDCmdAddRepositoryTest subclass: #MDCmdAddFileRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:36'!
expectedRepositoryName
	^ 'testrepo.mcr'! !

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:57'!
factory
	^ MDCmdAddFileRepository! !

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:32'!
repositoryType
	^ #McrFile! !

!MDCmdAddFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
test04ConditionAcceptsProject
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	node metaNode: self.
	self assert: (self 
			isActiveOn: node
			for: self)! !

MDCmdAddRepositoryTest subclass: #MDCmdAddMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:34'!
factory
	^ MDCmdAddMemoryRepository! !

!MDCmdAddMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:31'!
repositoryType
	^ #Memory! !

!MDCmdAddMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
test04ConditionAcceptsProject
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	node metaNode: self.
	self assert: (self 
			isActiveOn: node
			for: self)! !

MDCmdAddRepositoryTest subclass: #MDCmdAddNetRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/21/2008 20:26'!
factory
	^ MDCmdAddNetRepository! !

!MDCmdAddNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:32'!
repositoryType
	^ #Mnrp! !

!MDCmdAddNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
test04ConditionAcceptsProject
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	node metaNode: self.
	self assert: (self 
			isActiveOn: node
			for: self)! !

!MDCmdAddNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:29'!
test07WithPort
	| node repository |
	node := MDProjectNode 
		on: MDProject forTesting
		inEnvironment: MDEnvironment new.
	node metaNode: self.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBTextRequest
		do: [ :req | req resume: 'localhost:98888' ].
	self assert: node project repositories size = 1.
	repository := node project repositories anyOne.
	self assert: repository locator host = 'localhost'.
	self assert: repository locator port = 98888.
	
	self assert: (node environment repositories size = 1).
	self assert: (node environment repositories includes: repository)
	
! !

!MDCmdAddNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:29'!
test08WithoutPort
	| node repository |
	node := MDProjectNode 
		on: MDProject forTesting
		inEnvironment: MDEnvironment new.
	node metaNode: self.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBTextRequest
		do: [ :req | req resume: 'localhost' ].
	self assert: node project repositories size = 1.
	repository := node project repositories anyOne.
	self assert: repository locator host = 'localhost'.
	self assert: (node environment repositories size = 1).
	self assert: (node environment repositories includes: repository)
	
! !

!MDCmdAddRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/12/2008 22:12'!
isAbstract
	^ self name = #MDCmdAddRepositoryTest! !

!MDCmdAddRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/12/2008 22:07'!
announce: anObject! !

!MDCmdAddRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/12/2008 22:07'!
edgesForNode: aNode
	^ {OBMetaEdge selector: #repositories}! !

!MDCmdAddRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:36'!
expectedRepositoryName
	^ 'testrepo'! !

!MDCmdAddRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 22:21'!
test05ExecutionCanBeCancelled
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBInteractionRequest
		do: [ :req | req resume: nil ].
	self assert: node project repositories isEmpty.
	self assert: node environment repositories isEmpty.! !

!MDCmdAddRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:36'!
test06ExecutionAddsRepository
	| node repository |
	node := MDProjectNode 
		on: MDProject forTesting
		inEnvironment: MDEnvironment new.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBInteractionRequest
		do: [ :req | req resume: 'testrepo' ].
	self assert: node project repositories size = 1.
	repository := node project repositories anyOne.
	self assert: repository type = self repositoryType.
	self assert: repository name = self expectedRepositoryName.
	self assert: node environment repositories size = 1.
	self assert: (node environment repositories includes: repository)! !

OBCommandTest subclass: #MDCmdAddSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

MDCmdAddSliceTest subclass: #MDCmdAddChangeSetSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddChangeSetSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/12/2008 23:02'!
factory
	^ MDCmdAddChangeSetSlice ! !

!MDCmdAddChangeSetSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:42'!
sliceType
	^ #ChangeSet! !

!MDCmdAddChangeSetSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 12:05'!
test07ExecutionCanBeCancelled
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBInteractionRequest
		do: [ :req | req resume: nil ].
	self assert: node project slices isEmpty.
	self assert: node environment slices isEmpty.! !

MDCmdAddSliceTest subclass: #MDCmdAddPackageInfoSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddPackageInfoSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2008 20:09'!
factory
	^ MDCmdAddPackageInfoSlice! !

!MDCmdAddPackageInfoSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:31'!
sliceType
	^ #Package! !

!MDCmdAddPackageInfoSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 12:05'!
test07ExecutionCanBeCancelled
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBInteractionRequest
		do: [ :req | req resume: nil ].
	self assert: node project slices isEmpty.
	self assert: node environment slices isEmpty.! !

MDCmdAddSliceTest subclass: #MDCmdAddParentSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddParentSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2008 16:01'!
factory
	^ MDCmdAddParentSlice! !

!MDCmdAddParentSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:41'!
sliceType
	^ #Parents! !

MDCmdAddSliceTest subclass: #MDCmdAddProjectConfigSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddProjectConfigSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2008 18:21'!
factory
	^ MDCmdAddProjectConfigSlice! !

!MDCmdAddProjectConfigSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:32'!
sliceType
	^  #ProjectConfig! !

!MDCmdAddSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 00:56'!
isAbstract
	^ self name = #MDCmdAddSliceTest! !

!MDCmdAddSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 01:01'!
shouldInheritSelectors 
	^ true! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:57'!
announce: anObject! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 00:58'!
edgesForNode: aNode
	^ {OBMetaEdge selector: #slices}! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:30'!
sliceType
	self subclassResponsibility! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:20'!
test04ConditionAcceptsUnselectedProject
	| node |
	node := MDProjectNode on: MDProject new inEnvironment: MDEnvironment new.
	node metaNode: self.
	isSelected := false.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test05ConditionRejectsSelectedSlice
	| node |
	node := MDSliceNode on: (MDExplicitSlice named: '') inEnvironment: MDEnvironment new.
	isSelected := true.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:22'!
test06ConditionRejectsSelectedProject
	| node |
	node := MDProjectNode on: MDProject new inEnvironment: MDEnvironment new.
	node metaNode: self.
	isSelected := true.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdAddSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:31'!
test08ExecutionAddsSlice
		| node slice |
	node := MDProjectNode 
		on: MDProject forTesting
		inEnvironment: MDEnvironment new.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBInteractionRequest
		do: [ :req | req resume: 'testslice' ].
	self assert: node project slices size = 1.
	slice := node project slices anyOne.
	self assert: slice type = self sliceType.
	self assert: node environment slices size = 1.
	self assert: (node environment slices includes: slice)! !

OBCommandTest subclass: #MDCmdAddToUnionSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdAddToUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:04'!
factory
	^ MDCmdAddToUnionSlice! !

!MDCmdAddToUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test04ConditionAcceptsSliceNodes
	| node |
	node := MDSliceNode on: MDExplicitSlice forTesting inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdAddToUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test05ConditionRequiresSelection
	| node |
	node := MDSliceNode on: MDExplicitSlice forTesting inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdApplyAllTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdApplyAllTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:17'!
factory
	^ MDCmdApplyAll! !

!MDCmdApplyAllTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
node
	| builder merge wc |
	builder := MDTestBuilder new.
	wc := MDWorkingCopy forTesting.
	merge := builder mergeIn: wc.
	^ MDInclusionNode 
		workspace: wc
		merges: (Array with: merge)! !

!MDCmdApplyAllTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test04ConditionAcceptsInclusion
	| node |
	node := MDInclusionNode new.
	isSelected := false.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdApplyAllTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test05ConditionRequiresParent
	| node |
	node := MDInclusionNode new.
	isSelected := true.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdApplyAllTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test06DisabledWhenConflictExists
	| node |
	node := self node.
	self deny: (self isEnabledOn: node for: self)! !

!MDCmdApplyAllTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test07EnabledWhenAllConflictsResolved
	| node |
	node := self node.
	node merges first chooseRemote.
	self assert: (self isEnabledOn: node for: self)! !

OBCommandTest subclass: #MDCmdBrowseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdBrowseTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:37'!
factory
	^ MDCmdBrowse! !

!MDCmdBrowseTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:43'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $b! !

!MDCmdBrowseTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
test04ConditionRequiresSelection
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self 
			isActiveOn: node
			for: self)! !

!MDCmdBrowseTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
test05ConditionAcceptsProject
	| node |
	node := MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self 
			isActiveOn: node
			for: self)! !

OBCommandTest subclass: #MDCmdDirectoryRepositoryTest
	instanceVariableNames: 'announcement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdDirectoryRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 23:41'!
isAbstract
	^ self name = #MDCmdDirectoryRepositoryTest! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:38'!
announce: anAnnouncement
	announcement := anAnnouncement! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:46'!
createNode
	^ MDRepositoryNode 
		on: (MDDirectoryRepository named: 'TestRepository')
		inEnvironment: MDEnvironment new.! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:38'!
factory
	self subclassResponsibility! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:46'!
test04ConditionAcceptsRepository
	| node |
	node := MDRepositoryNode 
		on: MDMemoryRepository new 
		inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test05ConditionIgnoresSlice
	| node |
	node := MDSliceNode on: (MDExplicitSlice named: '') inEnvironment: MDEnvironment new.
	isSelected := true.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:46'!
test06ConditionIgnoresParent
	| node |
	node := MDRepositoryNode on: MDMemoryRepository new inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:48'!
test08DisabledForOtherRepository
	| node |
	node := MDRepositoryNode 
		on: MDMemoryRepository new
		inEnvironment: MDEnvironment new.
	self deny: (self 
			isEnabledOn: node
			for: self)! !

MDCmdDirectoryRepositoryTest subclass: #MDCmdNilPrimaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdNilPrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:36'!
factory
	^ MDCmdNilPrimary! !

!MDCmdNilPrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:52'!
test07EnabledForDirectoryRepository
	| node |
	node := self createNode.
	node repository primaryName: 'abc'.
	self assert: (self isEnabledOn: node for: self)! !

!MDCmdNilPrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:58'!
test09UpdatesPrimaryName
	| node |
	node := self createNode.
	self executeOn: node for: self.
	self assert: node repository primaryName = MDPlatform current initials! !

!MDCmdNilPrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:59'!
test10AnnouncesChange
	| node |
	node := self createNode.
	self executeOn: node for: self.
	self assert: announcement class = OBNodeChanged.! !

!MDCmdNilPrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 17:02'!
test11DisabledWhenAlreadyNil
	| node |
	node := self createNode.
	node repository primaryName: nil.
	self deny: (self isEnabledOn: node for: self)! !

MDCmdDirectoryRepositoryTest subclass: #MDCmdRenamePrimaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdRenamePrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:06'!
factory
	^ MDCmdRenamePrimary! !

!MDCmdRenamePrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:53'!
test07EnabledForDirectoryRepository
	| node |
	node := self createNode.
	self assert: (self isEnabledOn: node for: self)! !

!MDCmdRenamePrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:49'!
test09UpdatesPrimaryName
	| node |
	node := self createNode.
	[self executeOn: node for: self] 
		on: OBTextRequest
		do: [ :req | req resume: 'abc' ].
	self assert: node repository primaryName = 'abc'! !

!MDCmdRenamePrimaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:49'!
test10AnnouncesChange
	| node |
	node := MDRepositoryNode 
		on: (MDDirectoryRepository named: 'TestRepository')
		inEnvironment: MDEnvironment new.
	
	[ self 
		executeOn: node
		for: self ] 
		on: OBTextRequest
		do: [ :req | req resume: 'abc' ].
	self assert: announcement class = OBNodeChanged! !

OBCommandTest subclass: #MDCmdFileoutSnapshotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdFileoutSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:17'!
factory
	^ MDCmdFileoutSnapshot! !

!MDCmdFileoutSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:24'!
test04ConditionAcceptsMemo
	| node |
	node := MDMemoNode on: MDMemo new inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdFileoutSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:24'!
test05ConditionIgnoresParent
	| node |
	node := MDMemoNode on: MDMemo new inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdIncludeSnapshotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:49'!
factory
	^ MDCmdIncludeSnapshot! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:51'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $i! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:24'!
test04ConditionAcceptsMemo
	| node |
	node := MDMemoNode on: MDMemo new inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdIncludeSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:24'!
test05ConditionIgnoresParent
	| node |
	node := MDMemoNode on: MDMemo new inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdLoadSnapshotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:01'!
factory
	^ MDCmdLoadSnapshot! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:03'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $l! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:23'!
test04ConditionAcceptsMemo
	| node |
	node := MDMemoNode on: MDMemo new inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdLoadSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:24'!
test05ConditionIgnoresParent
	| node |
	node := MDMemoNode on: MDMemo new inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdMergeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

MDCmdMergeTest subclass: #MDCmdApplyResolutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdApplyResolutionTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 19:58'!
factory
	^ MDCmdApplyResolution! !

!MDCmdApplyResolutionTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:39'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $a! !

!MDCmdApplyResolutionTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test08DisabledOnConflict
	| node |
	self shouldTestEnabling ifTrue:
		[node := self mergeNode.
		self deny: (self isEnabledOn: node for: self)]! !

MDCmdMergeTest subclass: #MDCmdChooseLocalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdChooseLocalTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 20:14'!
factory
	^ MDCmdChooseLocal! !

!MDCmdChooseLocalTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:20'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $l! !

MDCmdMergeTest subclass: #MDCmdChooseRemoteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdChooseRemoteTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:06'!
factory
	^ MDCmdChooseRemote! !

!MDCmdChooseRemoteTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $r! !

MDCmdMergeTest subclass: #MDCmdLoadLocalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdLoadLocalTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:19'!
factory
	^ MDCmdLoadLocal! !

!MDCmdLoadLocalTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:29'!
shouldTestEnabling
	^ false! !

MDCmdMergeTest subclass: #MDCmdLoadRemoteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdLoadRemoteTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:29'!
factory
	^ MDCmdLoadRemote! !

!MDCmdLoadRemoteTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:47'!
shouldTestEnabling
	^ false! !

!MDCmdMergeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:09'!
isAbstract
	^ self name = #MDCmdMergeTest! !

!MDCmdMergeTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
mergeNode
	| wc |
	wc := MDWorkingCopy forTesting.
	^ MDMergeNode
		on: (MDTestBuilder new mergeIn: wc)
		inWorkspace: wc! !

!MDCmdMergeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:29'!
shouldTestEnabling
	^ true! !

!MDCmdMergeTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test04ConditionAcceptsMergeNode
	| node |
	node := self mergeNode.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdMergeTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test05ConditionRejectsParent
	| node |
	node := self mergeNode.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdMergeTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test06EnabledBeforeApplied
	| node |
	self shouldTestEnabling ifTrue:
		[node := self mergeNode.
		node chooseLocal.
		self assert: (self isEnabledOn: node for: self)]! !

!MDCmdMergeTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
test07DisabledAfterApplied
	| node |
	self shouldTestEnabling ifTrue:
		[node := self mergeNode.
		node chooseLocal; apply.
		self deny: (self isEnabledOn: node for: self)]! !

OBCommandTest subclass: #MDCmdRemoveProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdRemoveProjectTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 23:12'!
factory
	^ MDCmdRemoveProject! !

!MDCmdRemoveProjectTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
selectedNode
	^ MDProjectNode 
		on: MDProject new
		inEnvironment: MDEnvironment new! !

!MDCmdRemoveProjectTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:01'!
test04ConditionAcceptsRegistry
	| node |
	node := MDEnvironmentNode on: MDRegistry new.
	self assert: (self 
			isActiveOn: node
			for: self)! !

OBCommandTest subclass: #MDCmdRemoveRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:25'!
factory
	^ MDCmdRemoveRepository! !

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:30'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $x! !

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:48'!
test04ConditionAcceptsRepository
	| node |
	node := MDRepositoryNode 
		on: MDMemoryRepository new
		inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self 
			isActiveOn: node
			for: self)! !

!MDCmdRemoveRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:48'!
test05ConditionIgnoresParent
	| node |
	node := MDRepositoryNode 
		on: MDMemoryRepository new
		inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self 
			isActiveOn: node
			for: self)! !

OBCommandTest subclass: #MDCmdRemoveSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:27'!
factory
	^ MDCmdRemoveSlice! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:28'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $x! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test04ConditionAcceptsSlice
	| node |
	node := MDSliceNode on: (MDExplicitSlice named: '') inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdRemoveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test05ConditionIgnoresParent
	| node |
	node := MDSliceNode on: (MDExplicitSlice named: '') inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdSaveSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:36'!
factory
	^ MDCmdSaveSlice! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:30'!
shouldTestEnabling
	^ false! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:39'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $s! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:41'!
test04ConditionAcceptsSlice
	| node |
	node := MDSliceNode on: MDExplicitSlice new inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:40'!
test05ConditionIgnoresParent
	| node |
	node := MDSliceNode on: MDExplicitSlice new inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

!MDCmdSaveSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:41'!
test06WarnsOfNoRepositories
	| node exception |
	node := MDSliceNode on: MDExplicitSlice new inEnvironment: MDEnvironment new.
	[self executeOn: node for: self]
		on: OBInteractionRequest 
		do: [:req | exception := req].
	self deny: exception isNil.
	self assert: exception class = OBInformRequest.
	self assert: exception message = 'This project has no repositories'! !

OBCommandTest subclass: #MDCmdSaveSnapshotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSaveSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 23:51'!
factory
	^ MDCmdSaveSnapshot! !

!MDCmdSaveSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:26'!
test04ConditionAcceptsMemo
	| node |
	node := MDMemoNode 
		on: MDMemo new
		inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self 
			isActiveOn: node
			for: self)! !

!MDCmdSaveSnapshotTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:26'!
test05ConditionRejectsParent
	| node |
	node := MDMemoNode 
		on: MDMemo new
		inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self 
			isActiveOn: node
			for: self)! !

OBCommandTest subclass: #MDCmdShowChangesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdShowChangesTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 20:27'!
factory
	^ MDCmdShowChanges! !

!MDCmdShowChangesTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:41'!
test04ConditionAcceptsSlice
	| node |
	node := MDSliceNode on: MDExplicitSlice new inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self isActiveOn: node for: self)! !

!MDCmdShowChangesTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:41'!
test05ConditionIgnoresParent
	| node |
	node := MDSliceNode on: MDExplicitSlice new inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #MDCmdSyncRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDCmdSyncRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2007 00:15'!
factory
	^ MDCmdSyncRepository! !

!MDCmdSyncRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:48'!
test04ConditionAcceptsRepository
	| node |
	node := MDRepositoryNode 
		on: MDMemoryRepository new
		inEnvironment: MDEnvironment new.
	isSelected := true.
	self assert: (self 
			isActiveOn: node
			for: self)! !

!MDCmdSyncRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:48'!
test05ConditionIgnoresParent
	| node |
	node := MDRepositoryNode 
		on: MDMemoryRepository new
		inEnvironment: MDEnvironment new.
	isSelected := false.
	self deny: (self 
			isActiveOn: node
			for: self)! !

!MDCmdSyncRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:52'!
test06IsEnabledWhenProjectHasAnotherRepository
	| node environment |
	environment := MDEnvironment new.
	environment addRepository: (MDMemoryRepository named: 'one').
	environment addRepository: (MDMemoryRepository named: 'two').
	node := MDRepositoryNode 
				on: environment repositories first
				inEnvironment: environment.
	isSelected := false.
	self assert: (self isEnabledOn: node for: self)! !

!MDCmdSyncRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:50'!
test07IsDisabledWhenProjectHasNoOtherRepositories
	| node environment |
	environment := MDProject forTesting.
	environment addRepository: (MDMemoryRepository forTesting).
	node := MDRepositoryNode 
				on: environment repositories first
				inEnvironment: environment.
	isSelected := false.
	self deny: (self isEnabledOn: node for: self)! !

OBNode subclass: #MDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

MDNode subclass: #MDChangeNode
	instanceVariableNames: 'workspace change'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDChangeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:35'!
on: aChange inWorkspace: aWorkspace
	^ self new setWorkspace: aWorkspace change: aChange! !

!MDChangeNode methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:39'!
name
	^ change variant name! !

!MDChangeNode methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:34'!
setWorkspace: aWorkspace change: aChange
	workspace := aWorkspace.
	change := aChange! !

!MDChangeNode methodsFor: 'as yet unclassified' stamp: 'cwp 7/24/2008 07:10'!
text
	| class |
	class := change element domain = #smalltalk
		ifTrue: [Smalltalk classNamed: change element theClassName].
	^ TextDiffBuilder
		buildDisplayPatchFrom: change original definition text
		to: change final definition text
		inClass: class! !

MDNode subclass: #MDDiffNode
	instanceVariableNames: 'workspace slice changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDDiffNode class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:56'!
on: aSet forSlice: aSlice inWorkspace: aWorkspace
	^ self new setWorkspace: aWorkspace slice: aSlice changes: aSet! !

!MDDiffNode methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:38'!
changes
	^ changes collect: [:ea | MDChangeNode on: ea inWorkspace: workspace]! !

!MDDiffNode methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:56'!
setWorkspace: aWorkspace slice: aSlice changes: aSet
	workspace := aWorkspace.
	slice := aSlice.
	changes := aSet asSortedArray! !

!MDDiffNode methodsFor: 'accessing' stamp: 'cwp 5/24/2008 21:57'!
slice
	^ slice! !

MDNode subclass: #MDEnvironmentAwareNode
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDEnvironmentAwareNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:52'!
environment
	^ environment! !

MDEnvironmentAwareNode subclass: #MDEnvironmentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDEnvironmentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:06'!
on: anEnvironment
	^ self new setEnvironment: anEnvironment! !

!MDEnvironmentNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:03'!
isEnvironment
	^ true! !

!MDEnvironmentNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:05'!
projects
	^ (environment projects collect: [:ea | MDProjectNode on: ea inEnvironment: environment]) 
		asArray sort: [:a :b | a name <= b name]! !

!MDEnvironmentNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:05'!
setEnvironment: aRegistry 
	environment := aRegistry! !

MDEnvironmentAwareNode subclass: #MDMemoNode
	instanceVariableNames: 'memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDMemoNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:09'!
on: aMemo inEnvironment: anEnvironment
	^ self new setMemo: aMemo environment: anEnvironment! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
ancestrySelector
	^ #isDescendantOfMemo: ! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:36'!
browse
	| root |
	root := MDSnapshotNode on: self snapshot inEnvironment: environment.
	(MDSnapshotBrowser root: root) 
		name: memo name;
		open.
	! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2007 12:45'!
canBrowse
	^ true! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:05'!
definition
	^ MDMemoDefinition on: memo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:14'!
historian
	^ self environment historianWithId: memo sliceId! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
isDescendantOfMemo: aMemoNode
	^ aMemoNode reference = memo reference! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 23:04'!
isDescendantOfSlice: aSliceNode
	^ memo matchesSlice: aSliceNode slice! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:09'!
isMemo
	^ true! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:23'!
memo
	^ memo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 22:37'!
name
	^ memo name! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
reference
	^ memo reference! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:09'!
setMemo: aMemo environment: anEnvironment
	environment := anEnvironment.
	memo := aMemo.! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 09:37'!
snapshot
	^ self environment store get: self reference! !

MDEnvironmentAwareNode subclass: #MDProjectNode
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDProjectNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:53'!
on: aProject inEnvironment: anEnvironment
	^ self new setProject: aProject environment: anEnvironment! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:19'!
ancestrySelector
	^ #isDescendantOfProject:! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:43'!
browse
	MDProjectBrowser openOn: project! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:52'!
canBrowse
	^ true! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:01'!
definition
	^ MDProjectDefinition on: project! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 22:52'!
isProject
	^ true! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:07'!
name
	^ project name! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:52'!
project
	^ project! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 10:04'!
repositories
	^ project repositories collect: 
		[:ea | 
		(MDRepositoryNode on: ea inEnvironment: environment)
			project: project;
			yourself]! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:53'!
setProject: aProject environment: anEnvironment
	environment := anEnvironment.
	project := aProject.
	! !

!MDProjectNode methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 10:02'!
slices
	^ (project slices asArray sort: [:a :b | a name <= b name]) collect: 
		[:ea | 
		(MDSliceNode on: ea inEnvironment: environment)
			project: project;
			yourself]
		! !

MDEnvironmentAwareNode subclass: #MDRepositoryNode
	instanceVariableNames: 'project repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDRepositoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:45'!
on: aRepository inEnvironment: anEnvironment
	^ self new setRepository: aRepository environment: anEnvironment! !

!MDRepositoryNode methodsFor: 'actions' stamp: 'cwp 8/4/2008 21:33'!
browse
	MDRepositoryBrowser openRoot: self.! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 8/4/2008 21:34'!
canBrowse
	^ true! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 11/20/2007 00:20'!
isDescendantOfProject: aNode
	^ aNode project repositories includes: repository! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 6/15/2008 20:04'!
isEditable
	^ false! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 11/20/2007 00:28'!
isRepository
	^ true! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 8/18/2009 02:44'!
memos
	| memos |
	memos := repository memos asArray sort: [:a :b | b <= a].
	^ memos collect: [:ea | MDMemoNode on: ea inEnvironment: environment]! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 11/11/2007 21:55'!
name
	^ repository description! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 10:03'!
project
	^ project! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 10:03'!
project: anObject
	project := anObject! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 11/20/2007 00:32'!
repository
	^ repository! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 8/18/2009 02:45'!
setRepository: aRepository environment: anEnvironment
	repository := aRepository.
	environment := anEnvironment! !

MDEnvironmentAwareNode subclass: #MDSliceNode
	instanceVariableNames: 'project slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDSliceNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:37'!
on: aSlice inEnvironment: anEnvironment
	^ self new setSlice: aSlice environment: anEnvironment! !

!MDSliceNode methodsFor: 'ancestry' stamp: 'cwp 11/12/2007 22:42'!
ancestrySelector
	^ #isDescendantOfSlice: ! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 12/31/2007 15:02'!
definition
	^ MDSliceDefinition on: slice
		! !

!MDSliceNode methodsFor: 'testing' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ true! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 8/18/2009 02:37'!
memos
	| memos |
	memos := environment store memos select: [:ea | ea matchesSlice: slice].
	memos := memos asArray sort: [:a :b | b <= a].
	^ memos collect: [:ea | MDMemoNode on: ea inEnvironment: environment]! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 11/8/2007 22:21'!
name
	^ slice name! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 09:54'!
project
	^ project! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 09:54'!
project: anObject
	project := anObject! !

!MDSliceNode methodsFor: 'actions' stamp: 'cwp 8/14/2009 09:58'!
save
	self environment repositories isEmpty ifTrue:
		[OBInformRequest message: 'This project has no repositories'.
		^ nil].
	^ [self environment save: slice]
		on: MDCommentRequest 
		do: [:req | req resume: (OBTextRequest prompt: req messageText)]! !

!MDSliceNode methodsFor: 'initialize-release' stamp: 'cwp 8/18/2009 02:37'!
setSlice: aSlice environment: anEnvironment
	slice := aSlice.
	environment := anEnvironment! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 11/9/2007 01:01'!
slice
	^ slice! !

MDEnvironmentAwareNode subclass: #MDSnapshotNode
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDSnapshotNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:33'!
on: aSnapshot inEnvironment: anEnvironment
	^ self new setSnapshot: aSnapshot environment: anEnvironment! !

!MDSnapshotNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:09'!
name
	^ snapshot hashstamp asString! !

!MDSnapshotNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:34'!
setSnapshot: aSnapshot environment: anEnvironment
	snapshot := aSnapshot.
	environment := anEnvironment! !

!MDSnapshotNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:55'!
versions
	| versions |
	versions := (snapshot getVersionsFrom: environment store) asArray.
	^ (versions collect: [:ea | MDVersionNode on: ea inEnvironment: environment]) sort! !

MDEnvironmentAwareNode subclass: #MDVersionNode
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDVersionNode class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:54'!
on: aVersion inEnvironment: anEnvironment
	^ self new setVersion: aVersion environment: anEnvironment! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 18:53'!
<= other
	^ self name <= other name! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2007 22:55'!
definition
	^ version variant definition! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 19:08'!
name
	^ version variant name! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:54'!
setVersion: aVersion environment: anEnvironment
	version := aVersion.
	environment := anEnvironment! !

MDNode subclass: #MDInclusionNode
	instanceVariableNames: 'workspace merges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDInclusionNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 13:11'!
workspace: aWorkspace merges: aCollection
	^ self new setWorkspace: aWorkspace merges: aCollection! !

!MDInclusionNode methodsFor: 'comparing' stamp: 'cwp 12/16/2007 20:40'!
= other
	^ self == other! !

!MDInclusionNode methodsFor: 'actions' stamp: 'cwp 12/16/2007 20:31'!
applyAll
	merges do: [:ea | ea apply]! !

!MDInclusionNode methodsFor: 'comparing' stamp: 'cwp 12/16/2007 20:40'!
hash
	^ self identityHash! !

!MDInclusionNode methodsFor: 'testing' stamp: 'cwp 12/12/2007 23:20'!
isInclusion
	^ true! !

!MDInclusionNode methodsFor: 'navigation' stamp: 'cwp 12/16/2007 20:29'!
merges
	^ merges ! !

!MDInclusionNode methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 21:15'!
setWorkspace: aWorkspace merges: aCollection
	
	workspace := aWorkspace.
	merges := (aCollection collect: [:ea | MDMergeNode on: ea inWorkspace: workspace]) asArray.
	merges sort! !

MDNode subclass: #MDMergeNode
	instanceVariableNames: 'merge workspace variant isApplied'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDMergeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:34'!
on: aMerge inWorkspace: aWorkspace
	^ self new setMerge: aMerge workspace: aWorkspace! !

!MDMergeNode methodsFor: 'comparing' stamp: 'cwp 10/25/2008 14:37'!
<= other
	(self isApplied not and: [other isApplied]) ifTrue: [^ true].
	(self isApplied and: [other isApplied not]) ifTrue: [^ false].
	(self isResolved not and: [other isResolved]) ifTrue: [^ true].
	(self isResolved and: [other isResolved not]) ifTrue: [^ false].
	^ self name asString <= other name asString! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
apply
	variant
		ifNil: [merge applyTo: workspace]
		ifNotNil: [workspace includeVersion: merge remote onConflict: [:l :r | variant]].
	isApplied := true! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
chooseLocal
	merge chooseLocal.
	variant := nil! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
chooseRemote
	merge chooseRemote.
	variant := nil! !

!MDMergeNode methodsFor: 'testing' stamp: 'cwp 12/16/2007 20:30'!
isApplied
	^ isApplied! !

!MDMergeNode methodsFor: 'testing' stamp: 'cwp 12/11/2007 15:23'!
isMerge
	^ true! !

!MDMergeNode methodsFor: 'testing' stamp: 'cwp 12/17/2007 22:55'!
isResolved 
	^ variant notNil or: [merge isResolved]! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 12/12/2007 22:36'!
loadLocal
	workspace loadVersion: merge local! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 12/12/2007 22:37'!
loadRemote
	workspace loadVersion: merge remote! !

!MDMergeNode methodsFor: 'variant' stamp: 'cwp 12/17/2007 22:34'!
localVariant
	^ merge local variant! !

!MDMergeNode methodsFor: 'public' stamp: 'cwp 5/22/2008 21:15'!
name
	| name |
	name := String streamContents: [:s | merge displayOn: s].
	self isApplied ifTrue: [^ Text string: name attribute: TextEmphasis struckOut].
	self isResolved ifFalse: [^ Text string: name attribute: TextEmphasis bold].
	^ name
! !

!MDMergeNode methodsFor: 'variant' stamp: 'cwp 12/17/2007 22:35'!
remoteVariant
	^ merge remote variant! !

!MDMergeNode methodsFor: 'variant' stamp: 'cwp 12/17/2007 22:42'!
resolutionVariant
	^ variant ifNil: [merge isResolved ifTrue: [merge resolution variant]]
! !

!MDMergeNode methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 21:15'!
setMerge: aMerge workspace: aWorkspace
	merge := aMerge.
	workspace := aWorkspace.
	isApplied := false! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
variant: aVariant
	variant := aVariant! !

!MDNode methodsFor: 'testing' stamp: 'cwp 12/13/2007 21:52'!
canBrowse
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 8/16/2009 16:03'!
isEnvironment
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 12/12/2007 23:20'!
isInclusion
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/18/2007 00:09'!
isMemo
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 12/11/2007 15:23'!
isMerge
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/19/2007 22:52'!
isProject
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/20/2007 00:28'!
isRepository
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ false! !

OBNode subclass: #MDRepositoryMemoNode
	instanceVariableNames: 'repository memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDRepositoryMemoNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:18'!
on: aMemo inRepository: aRepository
	^ self new setMemo: aMemo repository: aRepository! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:29'!
canBrowse
	^ true! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:22'!
isMemo
	^ true! !

!MDRepositoryMemoNode methodsFor: 'accessing' stamp: 'cwp 11/28/2008 22:29'!
memo
	^ memo! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:18'!
name
	^ memo name! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2008 22:29'!
repository
	^ repository! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:18'!
setMemo: aMemo repository: aRepository
	memo := aMemo.
	repository := aRepository! !

OBNode subclass: #MDRepositoryRootNode
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Nodes'!

!MDRepositoryRootNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 22:48'!
on: aRepository
	^ self new setRepository: aRepository! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:22'!
isMemo
	^ false! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:25'!
memos
	| memos |
	memos := repository memos asArray sort: [:a :b | b <= a].
	^ memos collect: [:ea | MDRepositoryMemoNode on: ea inRepository: repository]! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:20'!
name
	^ repository description! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 22:49'!
setRepository: aRepository
	repository := aRepository! !

!MDRemovalVariant methodsFor: '*mc2-squeakui' stamp: 'cwp 12/16/2007 23:32'!
definition
	^ MDNullDefinition new! !

OBBrowser subclass: #MDBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

MDBrowser subclass: #MDAbstractProjectBrowser
	instanceVariableNames: 'lastRefresh needsRefresh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDAbstractProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 6/11/2008 23:58'!
projectMetanode
	| project slice repository memo |
	project := OBMetaNode named: 'project'.
	slice := OBMetaNode named: 'slice'.
	repository := OBMetaNode named: 'repository'.
	memo := OBMetaNode named: 'memo'.
	
	project 
		childAt: #slices put: slice;
		childAt: #repositories put: repository;
		addFilter: OBModalFilter new.
		
	repository 
		childAt: #memos put: memo;
		addFilter: MDMemoFilter new.
		
	slice 
		childAt: #memos put: memo;
		addFilter: MDSliceIconFilter new;
		addFilter: MDMemoFilter new.	
	
	^ project! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 6/14/2008 01:04'!
cmdAddChangeSetSlice
	^ MDCmdAddChangeSetSlice! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 8/21/2008 19:55'!
cmdAddDirectoryRepository
	^ MDCmdAddDirectoryRepository ! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/19/2007 23:58'!
cmdAddFileRepository
	^ MDCmdAddFileRepository! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/20/2007 00:37'!
cmdAddMemoryRepository
	^ MDCmdAddMemoryRepository ! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 5/27/2008 20:08'!
cmdAddPackageInfoSlice
	^ MDCmdAddPackageInfoSlice! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/11/2008 19:49'!
cmdAddProjectSlice
	^ MDCmdAddProjectSlice! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 6/14/2008 17:20'!
cmdAddToUnionSlice
	^ MDCmdAddToUnionSlice! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 12/13/2007 21:42'!
cmdBrowse
	^ MDCmdBrowse! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 4/4/2008 21:13'!
cmdFileoutSnapshot
	^ MDCmdFileoutSnapshot! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:24'!
cmdIncludeSnapshot
	^ MDCmdIncludeSnapshot! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/18/2007 00:22'!
cmdLoadSnapshot
	^ MDCmdLoadSnapshot! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/23/2008 17:00'!
cmdNilPrimary
	^ MDCmdNilPrimary! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 01:09'!
cmdPullFromRepository
	^ MDCmdPullFromRepository! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 01:10'!
cmdPushToRepository
	^ MDCmdPushToRepository! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/20/2007 00:32'!
cmdRemoveRepository
	^ MDCmdRemoveRepository! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/19/2007 23:33'!
cmdRemoveSlice
	^ MDCmdRemoveSlice! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/23/2008 16:22'!
cmdRenamePrimary
	^ MDCmdRenamePrimary! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 11/8/2007 23:00'!
cmdSaveSlice
	^ MDCmdSaveSlice! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 00:43'!
cmdSaveSnapshot
	^ MDCmdSaveSnapshot! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 5/24/2008 20:55'!
cmdShowChanges
	^ MDCmdShowChanges! !

!MDAbstractProjectBrowser methodsFor: 'commands' stamp: 'cwp 12/23/2007 00:34'!
cmdSyncRepository
	^ MDCmdSyncRepository! !

!MDAbstractProjectBrowser methodsFor: 'morphic' stamp: 'cwp 7/26/2008 18:07'!
initialize
	super initialize.
	needsRefresh := false.
	self register! !

!MDAbstractProjectBrowser methodsFor: 'updating' stamp: 'cwp 7/28/2008 19:41'!
noteAnnouncement: anAnnouncement
	needsRefresh := true! !

!MDAbstractProjectBrowser methodsFor: 'updating' stamp: 'cwp 8/3/2008 21:36'!
noteElementChange: ann
	ann element domain = #monticello ifTrue:
		[self noteAnnouncement: ann]! !

!MDAbstractProjectBrowser methodsFor: 'updating' stamp: 'cwp 7/26/2008 18:10'!
projects
	self subclassResponsibility! !

!MDAbstractProjectBrowser methodsFor: 'updating' stamp: 'cwp 8/3/2008 21:42'!
register
	MDAnnouncer default 
		observe: MDSliceTouched
		send: #noteAnnouncement:
		to: self.
	MDAnnouncer default
		observe: MDElementChange
		send: #noteElementChange:
		to: self.! !

!MDAbstractProjectBrowser methodsFor: 'morphic' stamp: 'cwp 7/26/2008 18:17'!
stepAt: milliseconds in: aSystemWindow
	needsRefresh ifTrue:
		[self signalRefresh.
		needsRefresh := false]! !

!MDAbstractProjectBrowser methodsFor: 'updating' stamp: 'cwp 7/28/2008 22:06'!
unregister
	MDAnnouncer default unsubscribe: self! !

!MDAbstractProjectBrowser methodsFor: 'morphic' stamp: 'cwp 3/9/2008 22:04'!
wantsStepsIn: aSystemWindow
	^ aSystemWindow model == self! !

!MDAbstractProjectBrowser methodsFor: 'morphic' stamp: 'cwp 7/26/2008 17:55'!
windowIsClosing
	self unregister! !

MDAbstractProjectBrowser subclass: #MDProjectBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:26'!
defaultMetaNode
	^ self projectMetanode! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:28'!
defaultRootNode
	^ MDProjectNode on: MDProject new inEnvironment: MDEnvironment default! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:27'!
openOn: aProject
	^ self openRoot: (MDProjectNode on: aProject)! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:27'!
paneCount
	^ 2! !

!MDProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:27'!
titleForRoot: aProjectNode
	^ 'Project - ', aProjectNode name! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:33'!
initialExtent
	^ 400@300! !

!MDProjectBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 18:11'!
projects
	^ Array with: self root project! !

MDAbstractProjectBrowser subclass: #MDProjectRegistryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDProjectRegistryBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
defaultMetaNode
	| root |
	root := OBMetaNode named: 'root'.
	root - #projects -> self projectMetanode.
	^ root! !

!MDProjectRegistryBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:01'!
defaultRootNode
	^ MDEnvironmentNode on: MDEnvironment default! !

!MDProjectRegistryBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:48'!
initialize
	self registerInOpenMenu ! !

!MDProjectRegistryBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:42'!
paneCount
	^ 3! !

!MDProjectRegistryBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 21:57'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Monticello Project Browser'. {self. #open}}.
! !

!MDProjectRegistryBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:43'!
title
	^ 'Monticello Projects'! !

!MDProjectRegistryBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:55'!
cmdAddProject
	^ MDCmdAddProject! !

!MDProjectRegistryBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/14/2007 23:59'!
cmdRemoveProject
	^ MDCmdRemoveProject! !

!MDProjectRegistryBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:43'!
initialExtent
	^ 500@300! !

!MDProjectRegistryBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 18:13'!
projects
	^ self root projects collect: [:ea | ea project]! !

!MDBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 14:42'!
panels
	^ Array
		with: self navigationPanel
		with: self definitionPanel! !

!MDBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:04'!
defaultBackgroundColor 
	^ (Color r: 0.627 g: 0.69 b: 0.976)! !

MDBrowser subclass: #MDChangesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDChangesBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:36'!
defaultMetaNode
	| diff change |
	diff := OBMetaNode named: 'diff'.
	change := OBMetaNode named: 'change'.
	diff - #changes -> change.
	^ diff! !

!MDChangesBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:49'!
paneCount
	^ 1! !

!MDChangesBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:55'!
titleForRoot: aNode
	^ 'Changes for ', aNode slice name! !

MDBrowser subclass: #MDConflictBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDConflictBrowser class methodsFor: 'configuration' stamp: 'cwp 5/22/2008 21:15'!
defaultMetaNode
	| root merge |
	root := OBMetaNode named: 'inclusion'.
	merge := OBMetaNode named: 'merge'.
	root - #merges -> merge.
	^ root! !

!MDConflictBrowser class methodsFor: 'opening' stamp: 'cwp 5/22/2008 21:15'!
handleRequest: aRequest
	| root |
	root := MDInclusionNode 
					workspace: aRequest workingCopy 
					merges: aRequest merges.
	(self root: root) open! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:45'!
localPanel
	^ MDLocalPanel new! !

!MDConflictBrowser class methodsFor: 'configuration' stamp: 'cwp 12/9/2007 10:58'!
paneCount
	^ 1! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:42'!
panels
	^ Array
		with: self navigationPanel
		with: self remotePanel
		with: self localPanel
		with: self resolutionPanel! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:45'!
remotePanel	
	^ MDRemotePanel new! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:46'!
resolutionPanel
	^ MDResolutionPanel new! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 10:58'!
buildOn: aBuilder
	^ aBuilder window: self with: 
		[aBuilder horizontalGroupWith:
			[panels first buildOn: aBuilder.
			panels second buildOn: aBuilder].
		aBuilder horizontalGroupWith:
			[panels third buildOn: aBuilder.
			panels fourth buildOn: aBuilder]]! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:23'!
cmdApplyAll
	^ MDCmdApplyAll! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:27'!
cmdChooseLocal
	^ MDCmdChooseLocal! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:08'!
cmdChooseRemote
	^ MDCmdChooseRemote! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 19:58'!
cmdIncludeResolution
	^ MDCmdApplyResolution! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:21'!
cmdLoadLocal
	^ MDCmdLoadLocal! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:31'!
cmdLoadRemote
	^ MDCmdLoadRemote! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 23:59'!
initialExtent
	^ 604@423! !

MDBrowser subclass: #MDRepositoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 11/27/2008 23:19'!
browseRepositoryFile: filename
	| repository root |
	repository := MDFileRepository on: (FileStream fileNamed: filename).
	root := MDRepositoryRootNode on: repository.
	self openRoot: root! !

!MDRepositoryBrowser class methodsFor: 'configuration' stamp: 'cwp 8/4/2008 21:17'!
defaultMetaNode
	| root memo |
	root := OBMetaNode named: 'root'.
	memo := OBMetaNode named: 'memo'.
	
	root - #memos -> memo.
	^ root! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:42'!
extension
	^ 'mcr'! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:43'!
fileReaderServicesForFile: fileName suffix: suffix
	^({ self extension. '*' } includes: suffix)
		ifTrue: [ self services ]
		ifFalse: [#()].
! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:49'!
initialize
	FileList registerFileReader: self! !

!MDRepositoryBrowser class methodsFor: 'configuration' stamp: 'cwp 8/4/2008 21:19'!
paneCount
	^ 1! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:53'!
serviceBrowseRepository
	^ SimpleServiceEntry
		provider: self
		label: 'browse'
		selector: #browseRepositoryFile:
		description: 'browse a repository'! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:46'!
services
	^ Array with: self serviceBrowseRepository! !

!MDRepositoryBrowser class methodsFor: 'configuration' stamp: 'cwp 8/12/2008 21:04'!
titleForRoot: aRepositoryNode
	^ 'Repository - ', aRepositoryNode name! !

!MDRepositoryBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:23'!
cmdBrowse
	^ MDCmdBrowse! !

!MDRepositoryBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:23'!
cmdFileoutSnapshot
	^ MDCmdFileoutSnapshot! !

!MDRepositoryBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:26'!
cmdSaveSnapshot
	^ MDCmdSaveSnapshot! !

MDBrowser subclass: #MDSnapshotBrowser
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Browsers'!

!MDSnapshotBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 18:35'!
defaultMetaNode
	| snapshot version |
	snapshot := OBMetaNode named: 'snapshot'.
	version := OBMetaNode named: 'version'.
	snapshot - #versions -> version.
	^ snapshot! !

!MDSnapshotBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 18:53'!
paneCount
	^ 1! !

!MDSnapshotBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:09'!
defaultLabel
	^ name ifNil: [self root name]! !

!MDSnapshotBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
name: aString
	name := aString! !

TestCase subclass: #MDDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

MDDefinitionTest subclass: #MDClassDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2008 22:16'!
expectedText
	^ 'Object subclass: BogusA
	category: ''Bogus-Base'''! !

!MDClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2008 22:16'!
newText
	^ 'Object subclass: BogusA
	category: ''Bogus-Format'''! !

!MDClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
variant
	| variant |
	variant := MDDefinitionVariant forElement: 
				(MDClassElement className: #BogusA).
	variant properties
		category: #'Bogus-Base';
		format: #normal;
		superclassName: #Object.
	^ variant! !

!MDDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 7/22/2008 22:44'!
isAbstract
	^ self name = #MDDefinitionTest! !

!MDDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/22/2008 22:42'!
expectedText
	self subclassResponsibility! !

!MDDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/22/2008 22:42'!
newText
	self subclassResponsibility! !

!MDDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:29'!
testAccept
	| variant definition new |
	variant := self variant.
	definition := variant definition.
	definition callback: [:v | new := v].
	definition accept: self newText notifying: nil.
	self deny: new isNil.
	self assert: new properties size = 3.
	self assert: new properties category = #'Bogus-Format'.
	self assert: new properties format = #normal.
	self assert: new properties superclassName = #Object.! !

!MDDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:27'!
testText
	| variant definition |
	variant := self variant.
	definition := variant definition.
	self assert: definition text = self expectedText! !

!MDDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/22/2008 22:42'!
variant
	self subclassResponsibility! !

MDDefinitionTest subclass: #MDSliceDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDSliceDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:28'!
expectedText
	^ 'elements: a Set()
name: ''TestSlice''
type: #Explicit
'! !

!MDSliceDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:28'!
newText
	^ 'elements: a Set()
name: ''TestSlice2''
type: #Explicit
'! !

!MDSliceDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:32'!
testAccept
	| variant definition new |
	variant := self variant.
	definition := variant definition.
	definition callback: [:v | new := v].
	definition accept: self newText notifying: nil.
	self deny: new isNil! !

!MDSliceDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:24'!
variant
	^ MDTestBuilder new sliceVariant! !

TestCase subclass: #MDMemoFilterTest
	instanceVariableNames: 'filter slice environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDMemoFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/11/2008 07:13'!
memoWithParents: anArray
	^ MDMemo
		snapshot: (MDSnapshot withVersions: #())
		slice: slice
		parents: (anArray collect: [:ea | ea hashstamp])
		properties: (MDPropertyDictionary new
					initials: 'abc';
					sliceName: 'TestSlice';
					ordinal: (anArray inject: 1 into: [:max :ea | ea properties ordinal max: max]))! !

!MDMemoFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 08:47'!
setUp
	filter := MDMemoFilter new.
	environment := MDEnvironment new.
	slice := MDExplicitSlice forTesting.
	environment addSlice: slice! !

!MDMemoFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:31'!
testChildLoaded
	| display parent child parentNode childNode |
	parent := self memoWithParents: #().
	child := self memoWithParents: {  parent  }.
	(environment historianWithId: parent sliceId) noteLoad: child.
	parentNode := MDMemoNode 
		on: parent
		inEnvironment: environment.
	childNode := MDMemoNode 
		on: child
		inEnvironment: environment.
	filter 
		nodesFrom: {  childNode. parentNode  }
		forNode: nil.
	display := filter 
		displayString: parentNode name
		forNode: parentNode.
	self deny: display isText! !

!MDMemoFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:30'!
testNoParents
	| memo node display |
	memo := self memoWithParents: #().
	node := MDMemoNode 
		on: memo
		inEnvironment: environment.
	filter 
		nodesFrom: {  node  }
		forNode: nil.
	display := filter 
		displayString: node name
		forParent: nil
		child: node.
	self assert: display isText! !

!MDMemoFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:30'!
testNodeLoaded
	| display parent parentNode |
	parent := self memoWithParents: #().
	(environment historianWithId: parent sliceId) noteLoad: parent.
	parentNode := MDMemoNode 
		on: parent
		inEnvironment: environment.
	filter 
		nodesFrom: {  parentNode  }
		forNode: nil.
	display := filter 
		displayString: parentNode name
		forParent: nil
		child: parentNode.
	self assert: display isText! !

!MDMemoFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:31'!
testParentLoaded
	| display parent child parentNode childNode |
	parent := self memoWithParents: #().
	child := self memoWithParents: {  parent  }.
	(environment historianWithId: parent sliceId) noteLoad: parent.
	parentNode := MDMemoNode 
		on: parent
		inEnvironment: environment.
	childNode := MDMemoNode 
		on: child
		inEnvironment: environment.
	filter 
		nodesFrom: {  childNode. parentNode  }
		forNode: nil.
	display := filter 
		displayString: childNode name
		forParent: nil
		child: childNode.
	self assert: display isText! !

TestCase subclass: #MDMethodDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
testAccept
	| variant definition source new |
	source := 'a ^ $B'.
	variant := self variant.
	definition := MDMethodDefinition on: variant.
	definition callback: [:v | new := v].
	definition accept: source notifying: nil.
	self deny: new isNil.
	self assert: new properties source = source.! !

!MDMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
testText
	| variant definition |
	variant := self variant.
	definition := MDMethodDefinition on: variant.
	self assert: definition text = variant properties source.! !

!MDMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
variant
	| variant |
	variant := MDDefinitionVariant forElement: 
				(MDMethodElement className: #BogusA selector: #a).
	variant properties
		category: #letters;
		initials: 'cwp';
		timestamp: MDTimestamp now;
		source: 'a ^ $A'.
	^ variant! !

TestCase subclass: #MDNodeAncestryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDNodeAncestryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:21'!
testMemoIdentity
	| memo environment a b |
	memo := MDMemo new.
	environment := MDEnvironment new.
	a := MDMemoNode on: memo inEnvironment: environment.
	b := MDMemoNode on: memo inEnvironment: environment.
	self assert: (a isAncestorOf: b)! !

!MDNodeAncestryTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 15:26'!
testProjectRepository
	| project repository pNode rNode environment |
	environment := MDEnvironment new.
	environment addDomain: MDSqueakDomain new.
	project := MDProject new. 
	repository := MDMemoryRepository forTesting.
	project addRepository: repository.
	pNode := MDProjectNode on: project inEnvironment: environment.
	rNode := MDRepositoryNode 
		on: repository
		inEnvironment: environment.
	self assert: (pNode isAncestorOf: rNode)! !

!MDNodeAncestryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:41'!
testSliceIsAncestor
	| memo environment a b slice  |
	environment := MDEnvironment new.
	slice := MDExplicitSlice named: 'test'.
	memo := MDMemo new.
	memo setSnapshot: (MDSnapshot withVersions: Set new) slice: slice.
	a := MDSliceNode on: slice inEnvironment: environment.
	b := MDMemoNode on: memo inEnvironment: environment.
	self assert: (a isAncestorOf: b)
! !

TestCase subclass: #MDSliceFilterTest
	instanceVariableNames: 'slice project filter node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:42'!
addSlice: aSlice
	slice := aSlice.
	project addSlice: slice.
	filter := MDSliceIconFilter new.
	node := MDSliceNode on: slice inEnvironment: self environment.
! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:32'!
environment
	^ project environment! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2008 13:42'!
setUp
	project := MDProject forTesting.! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2008 17:03'!
testMonticelloClean
	| element icon |
	self addSlice: (MDProjectConfigSlice on: project).
	element := MDProjectElement for: project.
	icon := filter icon: nil forNode: node.
	self assert: icon = #monticelloClean! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:32'!
testMonticelloDirty
	| element |
	self addSlice: (MDProjectConfigSlice on: project).
	element := MDProjectElement for: project.
	self environment noteElementChanged: element.
	self assert: (filter icon: nil forNode: node) = #monticelloDirty! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2008 13:45'!
testSmalltalkClean
	| element |
	self addSlice: MDExplicitSlice forTesting.
	element := MDClassElement className: #MBBogusA.
	slice addElement: element.
	self assert: (filter icon: nil forNode: node) = #smalltalkClean.! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:32'!
testSmalltalkDirty
	| element |
	self addSlice: MDExplicitSlice forTesting.
	element := MDClassElement className: #MDBogusA.
	slice addElement: element.
	self environment noteElementChanged: element.
	self assert: (filter 
			icon: nil
			forNode: node) = #smalltalkDirty! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2008 18:42'!
testUnionClean
	| icon |
	self addSlice: (MDUnionSlice name: 'TestSlice').
	icon := filter icon: nil forNode: node.
	self assert: icon = #blank! !

!MDSliceFilterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 22:32'!
testUnionDirty
	| element explicit |
	explicit := MDExplicitSlice forTesting.
	self addSlice: ((MDUnionSlice name: 'TestSlice')
					addSlice: explicit;
					yourself).
	element := MDClassElement className: #MDBogusA.
	explicit addElement: element.
	self environment noteElementChanged: element.
	self assert: (filter icon: nil forNode: node) = #compositeDirty! !

OBDefinition subclass: #MDDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2007 13:35'!
isEditable
	^ false! !

MDDefinition subclass: #MDNullDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDNullDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 21:40'!
callback: aBlock! !

!MDNullDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 23:33'!
text
	^ '-- null --'! !

MDDefinition subclass: #MDPropertiesDefintion
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

MDPropertiesDefintion subclass: #MDMemoDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDMemoDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:31'!
properties
	^ object properties copy
		removeKey: #initials ifAbsent: [];
		removeKey: #ordinal ifAbsent: [];
		removeKey: #comment ifAbsent: [];
		removeKey: #sliceName ifAbsent: [];
		yourself! !

!MDMemoDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:31'!
text
	^ String streamContents: 
		[:stream |
		self printPropertiesOn: stream.
		stream cr.
		object properties comment ifNotNilDo: [:c | stream nextPutAll: c]]! !

MDPropertiesDefintion subclass: #MDProjectDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDProjectDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:02'!
timestamp
	^ nil! !

!MDPropertiesDefintion class methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:03'!
on: anObject
	^ self new setObject: anObject! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 14:46'!
printPropertiesOn: aStream
	self propertiesDo: 
		[:key :value |
		aStream 
			nextPutAll: key asString;
			nextPut: $:;
			space;
			print: value;
			cr].
! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:31'!
properties
	^ object properties! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
propertiesDo: aBlock
	| dict |
	self timestamp ifNotNilDo: [:ts | aBlock value: #timestamp value: ts].
	dict := self properties.
	dict keys asSortedArray do: [:key | aBlock value: key value: (dict at: key)]! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
setObject: anObject
	object := anObject! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 14:46'!
text
	^ String streamContents: [:stream | self printPropertiesOn: stream]
			! !

!MDPropertiesDefintion methodsFor: 'accessing' stamp: 'cwp 12/31/2007 15:34'!
timestamp
	^ object timestamp! !

MDPropertiesDefintion subclass: #MDSliceDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

MDPropertiesDefintion subclass: #MDVariantDefinition
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

MDVariantDefinition subclass: #MDClassDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
accept: aText notifying: aRequestor
	
	| variant |
	variant := self parse: aText notifying: aRequestor.
	variant ifNil: [^ false].
	object := callback value: variant.
	^ true! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2008 23:48'!
formatFromSelector: aSelector
	aSelector = #weakSubclass: ifTrue: [^ #weak].
	aSelector = #variableSubclass: ifTrue: [^ #variable].
	aSelector = #variableByteSubclass: ifTrue: [^ #bytes].
	aSelector = #variableWordSubclass: ifTrue: [^ #words].
	^ #normal! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
formatSelector
	| format |
	format := self properties format.
	format = #weak ifTrue: [^ 'weakSubclass:' ].
	format = #variable ifTrue: [^ 'variableSubclass:'].
	format = #bytes ifTrue: [^ 'variableByteSubclass:'].
	format = #words ifTrue: [^ 'variableWordSubclass:'].
	^ 'subclass:'! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
parse: aText notifying: aRequestor
	| tokens element variant |
	tokens := Scanner new scanTokens: aText.
	self verify: tokens notifying: aRequestor ifFail: [^ nil].
	element := MDClassElement className: tokens third.
	variant := MDDefinitionVariant forElement: element.
	variant properties superclassName: tokens first.
	variant properties category: tokens fifth.
	variant properties format: (self formatFromSelector: tokens second).
	^ variant! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
text
	| properties |
	properties := self properties.
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: properties superclassName;
			space;
			nextPutAll: self formatSelector;
			space;
			nextPutAll: self variant element theClassName;
			crtab;
			nextPutAll: 'category: ''';
			nextPutAll: properties category;
			nextPut: $']! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2008 23:15'!
verify: tokens notifying: aRequestor ifFail: aBlock
	tokens size = 5 ifFalse: aBlock.
	tokens first isSymbol ifFalse: aBlock.
	(#(subclass: weakSubclass: variableSubclass: variableByteSubclass: variableWordSubclass:) 		includes: tokens second) ifFalse: aBlock.
	tokens third isSymbol ifFalse: aBlock.
	tokens fourth = #category: ifFalse: aBlock.
	tokens fifth isString ifFalse: aBlock.! !

MDVariantDefinition subclass: #MDEmptyDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDEmptyDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:14'!
callback: aBlock! !

!MDEmptyDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 00:33'!
text
	^ '-- present --'! !

MDVariantDefinition subclass: #MDMethodDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDMethodDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:32'!
text
	^ self properties source asText makeSelectorBold! !

!MDMethodDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
variantWithSource: aText
	
	| new |
	new := MDDefinitionVariant forElement: self variant element.
	new properties
		category: self variant properties category;
		initials: Utilities authorInitials;
		source: aText asString;
		timeStamp: MDTimestamp now.
	^ new! !

!MDMethodDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
verify: aText notifying: aRequestor ifFail: aBlock
	| class |
	class := self elementClass.
	class compilerClass new 
		compile: aText 
		in: class 
		notifying: aRequestor 
		ifFail: aBlock.
	! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/17/2007 22:03'!
adaptorForClassCommentElement: anElement
	^ self new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/31/2007 16:27'!
adaptorForClassElement: anElement
	^ MDClassDefinition new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/17/2007 22:03'!
adaptorForClassInstVarElement: anElement
	^ MDEmptyDefinition new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/17/2007 22:03'!
adaptorForClassVarElement: anElement
	^ MDEmptyDefinition new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/17/2007 22:03'!
adaptorForInstVarElement: anElement
	^ MDEmptyDefinition new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/17/2007 22:03'!
adaptorForMethodElement: anElement
	^ MDMethodDefinition new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 7/24/2008 07:13'!
adaptorForParentElement: anElement
	^ self new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 12/17/2007 22:03'!
adaptorForPoolImportElement: anElement
	^ MDEmptyDefinition new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 7/24/2008 07:12'!
adaptorForProjectElement: anElement
	^ self new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 7/24/2008 07:12'!
adaptorForRepositoryElement: anElement
	^ self new! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 7/23/2008 06:57'!
adaptorForSliceElement: anElement
	^ self new! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 5/22/2008 21:15'!
accept: aText notifying: aRequestor
	
	self verify: aText notifying: aRequestor ifFail: [^ false].
	object := callback value: (self variantWithSource: aText).
	^ true! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 5/22/2008 21:15'!
callback: aBlock
	callback := aBlock! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 12/31/2007 16:31'!
elementClass
	^ Smalltalk at: self variant element theClassName ifAbsent: [Object]! !

!MDVariantDefinition methodsFor: 'testing' stamp: 'cwp 12/31/2007 16:31'!
isEditable
	^ callback notNil! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 12/31/2007 16:17'!
timestamp
	^ nil! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 12/31/2007 15:32'!
variant
	^ object! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 5/22/2008 21:15'!
variant: aVariant
	object := aVariant! !

!MDVariantDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 7/23/2008 07:30'!
variantWithSource: aByteString 
	^ object! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 12/31/2007 16:32'!
verify: aText notifying: aRequestor ifFail: aBlock
! !

MDDefinition subclass: #MDUndefinedDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Definitions'!

!MDUndefinedDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 21:43'!
callback: aBlock! !

!MDDefinitionVariant methodsFor: '*mc2-squeakui' stamp: 'cwp 12/29/2007 22:22'!
definition
	^ (element adaptedFor: MDVariantDefinition)
		variant: self;
		yourself! !

!MDDefinitionVariant methodsFor: '*mc2-squeakui' stamp: 'cwp 7/26/2008 16:39'!
name
	^ properties name ifNil: [self element printString]! !

!OBMorphicIcons methodsFor: '*mc2-squeakui-icons' stamp: 'cwp 8/10/2008 18:45'!
compositeDirty
	^  (Form
		extent: 12@12
		depth: 32
		fromArray: #( 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 0 0 0 0 0 0 0 0 4294901760 4294901760 0 0 0 0 0 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
		offset: 0@0)! !

!OBMorphicIcons methodsFor: '*mc2-squeakui-icons' stamp: 'cwp 6/7/2008 13:02'!
monticelloClean
	^ Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 0 4278190080 4278190080 0 4278190080 4278190080 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 4278190080 4278190080 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0)
	offset: 0@0! !

!OBMorphicIcons methodsFor: '*mc2-squeakui-icons' stamp: 'cwp 6/13/2008 20:43'!
monticelloDirty
	^ (Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 4278190080 0 4294901760 4294901760 4294901760 4294901760 0 0 0 0 4278190080 4278190080 0 4278190080 4294967295 4294901760 4294901760 0 0 0 4278190080 4278190080 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 4278190080 4278190080 4278190080 4278190080 4278190080 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294901760 0 4278190080 0 4278190080 0 4278190080 0 4294967295 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*mc2-squeakui-icons' stamp: 'cwp 6/15/2008 12:36'!
smalltalkClean
	^ Form
		extent: 12@12
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190088 4278190088 0 0 4278190088 0 0 4278190088 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 4278190088 0 0 4278190088 0 0 4278190088 4278190088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
		offset: 0@0! !

!OBMorphicIcons methodsFor: '*mc2-squeakui-icons' stamp: 'cwp 6/15/2008 12:37'!
smalltalkDirty
	^ Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 0 4278190088 4278190088 0 0 4278190088 0 0 4294901760 4294901760 0 0 0 4278190088 0 0 0 4278190088 0 4294901760 4294901760 4294901760 4294901760 0 0 4278190088 0 0 0 4278190088 4294901760 4294901760 0 4294967295 4294901760 4294901760 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 4278190088 0 0 4278190088 0 0 4278190088 4278190088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0! !

MDAdaptionTest subclass: #MDMonticelloDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDMonticelloDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2008 18:52'!
shouldInheritSelectors
	^ false! !

!MDMonticelloDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2008 18:49'!
adaptorSelectors
	^ #(text selection accept:notifying:)! !

!MDMonticelloDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2008 18:49'!
setUp
	proxy := MDVariantDefinition! !

!MDMonticelloDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/24/2008 07:12'!
testParent
	self tryAdapting: (MDParentElement 
						projectId: MDHashstamp new 
						sliceId: MDHashstamp new)! !

!MDMonticelloDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/24/2008 07:11'!
testProject
	self tryAdapting: (MDProjectElement id: MDHashstamp new)! !

!MDMonticelloDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/24/2008 07:05'!
testRepository
	self tryAdapting: (MDRepositoryElement 
						projectId: MDHashstamp new 
						repositoryId: MDHashstamp new)! !

!MDMonticelloDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2008 18:58'!
testSlice
	self tryAdapting: (MDSliceElement 
						projectId: MDHashstamp new 
						sliceId: MDHashstamp new)! !

MDAdaptionTest subclass: #MDSqueakDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Tests'!

!MDSqueakDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 23:59'!
adaptorSelectors
	^ #(text selection accept:notifying:)! !

!MDSqueakDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
setUp
	proxy := MDVariantDefinition! !

!MDVariant methodsFor: '*mc2-squeakui' stamp: 'cwp 7/26/2008 16:39'!
name
	^ self element printString! !

OBCommand subclass: #MDCmdAddProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddProject methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 16:59'!
createProjectNamed: name 
	| project |
	project := MDProject named: name.
	target environment addProject: project.
	^ project! !

!MDCmdAddProject methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 17:00'!
execute
	| name node |
	name := OBTextRequest prompt: 'Project name:'.
	name ifNotNil:
		[node := MDProjectNode 
			on: (self createProjectNamed: name)
			inEnvironment: target environment.
		node announceCreationWith: requestor]! !

!MDCmdAddProject methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2007 00:22'!
group
	^ #adding! !

!MDCmdAddProject methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:02'!
isActive
	^ target isEnvironment! !

!MDCmdAddProject methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 20:49'!
label
	^ 'add project...'! !

OBCommand subclass: #MDCmdAddRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDCmdAddRepository subclass: #MDCmdAddDirectoryRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2008 19:54'!
createRepository
	^ (OBTextRequest prompt: 'Directory name?')
		ifNotNilDo: [:name | MDDirectoryRepository named: name]! !

!MDCmdAddDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2008 19:52'!
label
	^ 'add directory repository...'! !

MDCmdAddRepository subclass: #MDCmdAddFileRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddFileRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:14'!
createRepository
	^ (OBTextRequest prompt: 'Filename?')
		ifNotNilDo: [:name | MDFileRepository named: name]! !

!MDCmdAddFileRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:56'!
label
	^ 'add file repository...'! !

MDCmdAddRepository subclass: #MDCmdAddMemoryRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:14'!
createRepository
	| name |
	name := OBTextRequest prompt: 'Enter repository name'.
	^ name ifNotNil: [MDMemoryRepository named: name]! !

!MDCmdAddMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2008 15:21'!
label
	^ 'add memory repository...'! !

MDCmdAddRepository subclass: #MDCmdAddNetRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddNetRepository methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:16'!
createRepository
	| host port |
	^ (OBTextRequest prompt: 'host[:port]')
		ifNotNilDo: 
			[:specifier | 
			(specifier includes: $:)
				ifFalse: [MDNetRepository host: specifier]
				ifTrue:
					[host := specifier upTo: $:.
					port := (specifier allButFirst: host size + 1) asNumber.
					MDNetRepository host: host port: port]]! !

!MDCmdAddNetRepository methodsFor: 'as yet unclassified' stamp: 'cwp 1/21/2008 20:27'!
label
	^ 'add network repository...'! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 11:34'!
execute
	| repository |
	repository := self createRepository.
	repository ifNotNil:
		[target environment addRepository: repository toProject: target project.
		(MDRepositoryNode on: repository inEnvironment: target environment)
			announceCreationWith: requestor]! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:50'!
group
	^ #project! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/5/2007 01:14'!
isActive
	^ target isProject and: 
		[(target metaNode edgesForNode: target) anySatisfy: [:ea | ea label = 'repositories']]! !

OBCommand subclass: #MDCmdAddSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDCmdAddSlice subclass: #MDCmdAddChangeSetSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddChangeSetSlice methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:42'!
execute
	| changeSet slice |
	changeSet := OBChoiceRequest 
		prompt: 'Please choose a change set.'
		labels: (ChangeSet allChangeSets collect: [:ea | ea name])
		values: ChangeSet allChangeSets.
	changeSet ifNotNil:
		[slice := MDChangeSetSlice on: changeSet.
		self ensureDomain: #smalltalk with: [MDSqueakDomain new].
		target environment addSlice: slice toProject: target project.
		(MDSliceNode on: slice inEnvironment: target environment) 
			announceCreationWith: requestor]! !

!MDCmdAddChangeSetSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 00:29'!
label
	^ 'add changeset slice...'! !

MDCmdAddSlice subclass: #MDCmdAddPackageInfoSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddPackageInfoSlice methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:43'!
execute
	| name slice |
	name := OBTextRequest prompt: 'Enter the name of the slice'.
	name ifNotNil: 
		[slice := MDPackageInfoSlice named: name.
		self ensureDomain: #smalltalk with: [MDSqueakDomain new].
		target environment addSlice: slice toProject: target project.
		(MDSliceNode on: slice inEnvironment: target environment) 
			announceCreationWith: requestor]! !

!MDCmdAddPackageInfoSlice methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2008 20:13'!
label
	^ 'add packageinfo slice...'! !

MDCmdAddSlice subclass: #MDCmdAddParentSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddParentSlice methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:44'!
execute
	| slice |
	slice := MDParentsSlice on: target project.
	self ensureDomain: #monticello with: [MDMonticelloDomain on: MDProject registry].
	target environment addSlice: slice toProject: target project.
	(MDSliceNode on: slice inEnvironment: target environment) 
		announceCreationWith: requestor! !

!MDCmdAddParentSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2008 14:16'!
label
	^ 'add snapshot slice'! !

MDCmdAddSlice subclass: #MDCmdAddProjectConfigSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddProjectConfigSlice methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2009 13:56'!
execute
	| slice |
	slice := MDProjectConfigSlice on: target project.
	self ensureDomain: #monticello with: [MDMonticelloDomain on: MDProject registry].
	target environment addSlice: slice toProject: target project.
	(MDSliceNode on: slice inEnvironment: target environment) 
		announceCreationWith: requestor! !

!MDCmdAddProjectConfigSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2008 17:07'!
label
	^ 'add project config slice'! !

MDCmdAddSlice subclass: #MDCmdAddProjectSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddProjectSlice methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:39'!
execute
	| slice |
	slice := MDProjectSlice on: target project.
	self ensureDomain: #monticello with: [MDMonticelloDomain on: MDProject registry].
	target project addSlice: slice.
	(MDSliceNode on: slice inEnvironment: target environment) 
		announceCreationWith: requestor! !

!MDCmdAddProjectSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2008 19:47'!
label
	^ 'add project slice'! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 13:22'!
ensureDomain: aSymbol with: aBlock 
	| workspace |
	workspace := target environment workspace.
	(workspace hasDomainNamed: aSymbol) ifFalse: 
		[workspace domainAt: aSymbol put: aBlock value]! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/6/2008 23:18'!
group
	^ #project! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/6/2008 23:18'!
isActive
	^ target isProject 
		and: [(requestor isSelected: target) not]
		and: [(target metaNode edgesForNode: target) anySatisfy: [:ea | ea label = 'slices']]! !

OBCommand subclass: #MDCmdAddToUnionSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:23'!
createSlice
	| name slice |
	name := OBTextRequest prompt: 'Enter the name of the slice:'.
	slice := MDUnionSlice name: name.
	target project addSlice: slice.
	^ slice! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:18'!
execute
	| union |
	union := self getSliceFromUser ifNil: [^ self].
	union addSlice: target slice.! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:48'!
getSliceFromUser
	| choices slice |
	choices := target project slices select: [:ea | ea isKindOf: MDUnionSlice].
	choices := choices reject: [:ea | ea includesSlice: target slice].
	slice := OBChoiceRequest
		prompt: 'Choose a slice'
		labels: ((choices collect: [:ea | ea name]) copyWithFirst: 'new...')
		values: (choices copyWithFirst: #new)
		lines: #(1).
	^ slice == #new
		ifFalse: [slice]
		ifTrue: [self createSlice]! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:26'!
group
	^ #project! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:09'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:05'!
label
	^ 'add to union slice...'! !

OBCommand subclass: #MDCmdApplyAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 20:33'!
execute
	target applyAll.
	target announceChildrenChangedWith: requestor ! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:52'!
group
	^ #all! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:22'!
isActive
	^ target isInclusion and: [(requestor isSelected: target) not]! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:46'!
isEnabled
	^ target merges allSatisfy: [:ea | ea isResolved]! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:18'!
label
	^ 'apply all'! !

OBCommand subclass: #MDCmdBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:44'!
execute
	target browse! !

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:54'!
isActive
	^ (requestor isSelected: target) and: [target canBrowse]! !

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:44'!
keystroke
	^ $b! !

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:35'!
label
	^ 'browse'! !

OBCommand subclass: #MDCmdFileoutSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'jf 10/25/2008 13:57'!
execute
	| exporter file |
	MDPlatform current
		withCursor: #write
		do:	[file := self openFile.
			[exporter := MDFileOutExporter on: file.
			exporter
				export: target memo
				from: target project store]
					ensure: [file close]]! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:31'!
group
	^ #exporting! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:26'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:18'!
label
	^ 'fileout'! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 21:17'!
openFile
	^ FileDirectory default forceNewFileNamed: (target memo name, '.st')! !

OBCommand subclass: #MDCmdIncludeSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 09:47'!
execute
	target environment include: target memo! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:54'!
group
	^ #loading! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:53'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:51'!
keystroke
	^ $i! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:50'!
label
	^ 'include'! !

OBCommand subclass: #MDCmdLoadSnapshot
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 09:50'!
execute
	target environment load: target memo! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:06'!
group
	^ #loading! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:11'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:04'!
keystroke
	^ $l! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:01'!
label
	^ 'load'! !

OBCommand subclass: #MDCmdRemoveProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdRemoveProject methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 17:01'!
execute
	| environment project |
	environment := target environment.
	project := requestor selectedNode project.
	environment removeProjectId: project id.
	MDAnnouncer announce: (MDElementRemoved for: (MDProjectElement for: project))! !

!MDCmdRemoveProject methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:02'!
isActive
	| node |
	node := requestor selectedNode.
	^ target isEnvironment 
		and: [node notNil]
		and: [node isProject]! !

!MDCmdRemoveProject methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 23:13'!
label
	^ 'remove'! !

OBCommand subclass: #MDCmdRemoveRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:31'!
execute
	target project removeRepository: target repository.
	target announceDeletionWith: requestor! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/6/2008 20:54'!
group
	^ #project! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2007 00:31'!
isActive
	^ target isRepository and: [requestor isSelected: target]! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:30'!
keystroke
	^ $x! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:33'!
label
	^ 'remove'! !

OBCommand subclass: #MDCmdRemoveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:39'!
execute
	target project removeSlice: target slice.
	target announceDeletionWith: requestor! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:34'!
group
	^ #project! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:30'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:28'!
keystroke
	^ $x! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:34'!
label
	^ 'remove slice'! !

OBCommand subclass: #MDCmdSaveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 18:31'!
execute
	| memo |
	memo := target save.
	memo ifNotNil: 
		[(MDMemoNode on: memo inProject: target project)
			announceCreationWith: requestor].
	target announceChangedWith: requestor! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:52'!
group
	^ #saving! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:01'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:37'!
keystroke
	^ $s! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:00'!
label
	^ 'save'! !

OBCommand subclass: #MDCmdSaveSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:55'!
execute
	| source snapshot versions destination |
	source := target project store.
	snapshot := (source get: target memo reference) ifNil: [^ self readError].
	versions := snapshot contents collect: [:ea | (source get: ea) ifNil: [^ self readError]].
	destination := MDFileRepository named: target memo name.
	[destination put: target memo.
	destination put: snapshot.
	destination putAll: versions]
		ensure: [destination close]
	! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:50'!
group
	^ #exporting! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:01'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 23:54'!
label
	^ 'save to file'! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:39'!
readError
	OBInformRequest message: 'Some data was not available'! !

OBCommand subclass: #MDCmdShowChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdShowChanges methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 13:22'!
execute
	| node changes |
	changes := MDPlatform current
		withCursor: #wait 
		do: [target environment changesForSlice: target slice].
	changes isEmpty
		ifTrue: 
			[target environment noteClean: target slice]
		ifFalse: 
			[target environment noteDirty: target slice.
			node := MDDiffNode 
				on: changes
				forSlice: target slice
				inWorkspace: target environment workspace.
			MDChangesBrowser openRoot: node]! !

!MDCmdShowChanges methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 20:38'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdShowChanges methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 20:26'!
label
	^ 'show changes...'! !

OBCommand subclass: #MDDirectoryRepositoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDDirectoryRepositoryCommand subclass: #MDCmdNilPrimary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdNilPrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:58'!
execute
	target repository primaryName: nil.
	target announceChangedWith: requestor
	! !

!MDCmdNilPrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 17:07'!
isEnabled
	^ super isEnabled and: [target repository hasPrimaryName]! !

!MDCmdNilPrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:37'!
label
	^ 'use default primary'! !

MDDirectoryRepositoryCommand subclass: #MDCmdRenamePrimary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdRenamePrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:31'!
execute
	| newName |
	newName := OBTextRequest prompt: 'Enter new name:'.
	newName ifNotNil:
		[target repository primaryName: newName.
		target announceChangedWith: requestor].
	! !

!MDCmdRenamePrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:07'!
label
	^ 'rename primary...'! !

!MDDirectoryRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:45'!
isActive
	^ target isRepository and: [requestor isSelected: target]! !

!MDDirectoryRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:46'!
isEnabled
	^ target repository class type = #McrDirectory! !

OBCommand subclass: #MDMergeCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDMergeCommand subclass: #MDCmdApplyResolution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 20:11'!
execute
	target apply.
	target announceChangedWith: requestor! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:22'!
group
	^ #choosing! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:44'!
isEnabled
	^ target isResolved and: [target isApplied not]! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:40'!
keystroke
	^ $a! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:38'!
label
	^ 'apply resolution'! !

MDMergeCommand subclass: #MDCmdChooseLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:28'!
execute
	target chooseLocal.
	target announceChangedWith: requestor! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:45'!
isEnabled
	^ target isApplied not! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:20'!
keystroke
	^ $l! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 20:14'!
label
	^ 'choose local'! !

MDMergeCommand subclass: #MDCmdChooseRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:09'!
execute
	target chooseRemote.
	target announceChangedWith: requestor! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:45'!
isEnabled
	^ target isApplied not! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
keystroke
	^ $r! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
label
	^ 'choose remote'! !

MDMergeCommand subclass: #MDCmdLoadLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdLoadLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:25'!
execute
	target loadLocal! !

!MDCmdLoadLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:20'!
group
	^ #loading! !

!MDCmdLoadLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:20'!
label
	^ 'load local'! !

MDMergeCommand subclass: #MDCmdLoadRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdLoadRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:32'!
execute
	^ target loadRemote! !

!MDCmdLoadRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:30'!
group
	^ #loading! !

!MDCmdLoadRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:30'!
label
	^ 'load remote'! !

!MDMergeCommand methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:12'!
group
	^ #choosing! !

!MDMergeCommand methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:06'!
isActive
	^ target isMerge and: [requestor isSelected: target]! !

OBCommand subclass: #MDSyncCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

MDSyncCommand subclass: #MDCmdPullFromRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdPullFromRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:18'!
execute
	self chooseRepositoryDo: [:other | other pushTo: target repository]! !

!MDCmdPullFromRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:07'!
label
	^ 'pull from...'! !

MDSyncCommand subclass: #MDCmdPushToRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdPushToRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:19'!
execute
	self chooseRepositoryDo: [:other | target repository pushTo: other]! !

!MDCmdPushToRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:06'!
label
	^ 'push to...'! !

MDSyncCommand subclass: #MDCmdSyncRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Commands'!

!MDCmdSyncRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:20'!
execute
	self chooseRepositoryDo: [:other | target repository synchronizeWith: other]! !

!MDCmdSyncRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2007 00:16'!
label
	^ 'sync with...'! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:19'!
chooseRepositoryDo: aBlock
	| choices repository |
	choices := target project repositories copyWithout: target repository.
	repository := OBChoiceRequest 
		prompt: 'Choose a repository'
		labels: (choices collect: [ :ea | ea description ])
		values: choices.
	repository ifNotNil:
		[self waitCursorDuring: [aBlock value: repository]]! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:09'!
group
	^ #sync! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:05'!
isActive
	^ target isRepository and: [requestor isSelected: target]! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:52'!
isEnabled
	^ target environment repositories anySatisfy: [:ea | ea ~~ target repository]! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:13'!
waitCursorDuring: aBlock
	MDPlatform current withCursor: #wait do: aBlock! !

OBDefinitionPanel subclass: #MDVersionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

MDVersionPanel subclass: #MDLocalPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

!MDLocalPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:49'!
variant
	^ node localVariant! !

MDVersionPanel subclass: #MDRemotePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

!MDRemotePanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:49'!
variant
	^ node remoteVariant! !

MDVersionPanel subclass: #MDResolutionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakUI-Panels'!

!MDResolutionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
defaultDefinition
	| variant |
	variant := self variant.
	^ variant
		ifNil: [MDUndefinedDefinition new]
		ifNotNil: [variant definition]! !

!MDResolutionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:49'!
variant
	^ node resolutionVariant.
	! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:48'!
defaultDefinition
	^ self variant definition! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:27'!
definition: aDefinition
	aDefinition callback: [:variant | self handleVariant: variant].
	super definition: aDefinition! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:53'!
handleVariant: aVariant
	node variant: aVariant.
	node announceChangedWith: self.
	^ self variant! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
node: aNode
 	node := aNode.
	node ifNotNil: [self definition: self defaultDefinition]! !
MDProjectRegistryBrowser initialize!
MDRepositoryBrowser initialize!
